Index: channel.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channel.c,v
retrieving revision 1.189
diff -u -r1.189 channel.c
--- channel.c	21 Apr 2005 06:02:43 -0000	1.189
+++ channel.c	21 Apr 2005 12:32:17 -0000
@@ -1251,9 +1251,10 @@
 		return -1;
 	/* Wait for a digit, no more than ms milliseconds total. */
 	while(ms) {
+		errno = 0;
 		rchan = ast_waitfor_nandfds(&c, 1, &cmdfd, (cmdfd > -1) ? 1 : 0, NULL, &outfd, &ms);
 		if ((!rchan) && (outfd < 0) && (ms)) { 
-			if (errno == EINTR)
+			if (errno == 0 || errno == EINTR)
 				continue;
 			ast_log(LOG_WARNING, "Wait failed (%s)\n", strerror(errno));
 			return -1;
